<template>
  <div>
    <v-progress-linear v-if="loading" indeterminate color="primary">
    </v-progress-linear>
    <panZoom :options="{
      initialZoom: 1,
      minZoom: 0.5,
      maxZoom: 2,
      bounds: true,
      boundsPadding: 0.4
    }" @init="onInitPanzoom">
      <div class="seats-map" :class="{ 'loading': loading }">
        <v-row v-for="(zone, x) in zones" :key="x" no-gutters>
          <v-col md="auto" class="seats-zone" :class="{
            'background-color-zone-a': zone.name === 'OA',
            'background-color-zone-b': zone.name === 'OB',
            'background-color-zone-c': zone.name === 'OC',
            'background-color-zone-d': zone.name === 'OD'
          }">
            {{ zone.name }} - {{ getNbPaxByZone(zone.name) }}
          </v-col>
          <v-col>
            <v-row v-for="(row, y) in zone.rows" :key="y" no-gutters class="seats-row">
              <template v-for="(col, index) in columns">
                <v-spacer v-if="col.header && columns[index + 1] === 'H'"></v-spacer>
                <v-menu v-model="menuRefs['menu' + row + col]" offset-y
                  :disabled="!(modes.commentMode || (modes.placeMode && !(getCellSeat(col, row)?.blocked ?? false))) || movePax"
                  :close-on-content-click="false">
                  <template #activator="{ props }">
                    <v-col class="seat-cell" :class="getCellClasses(col, row)">
                      <div v-if="row.header && !col.header">
                        {{ col }}
                      </div>
                      <div v-else-if="col.header && !row.header">
                        {{ row }}
                      </div>
                      <div v-else-if="!col.header && !row.header"
                        :draggable="modes.placeMode && getCellSeat(col, row)?.pax" v-bind="props"
                        @dragstart="startDrag($event, col, row)" @dragend="endDrag()" @drop="onDrop($event, col, row)"
                        @dragover.prevent @dragenter.prevent @click="handleCellClick(col, row)"
                        v-sanitize-html="getCellDisplay(col, row)">
                      </div>
                    </v-col>
                  </template>
                  <template #default>
                    <LazyFlightsCaseSeatsSeatComment v-if="modes.commentMode" :seat="getCellSeat(col, row)!"
                      @close="menuRefs['menu' + row + col] = false" />
                    <LazyFlightsCaseSeatsSeatPlace v-if="modes.placeMode" :available-paxs="getAvailablePaxs()"
                      :seat="getCellSeat(col, row)!" @close="menuRefs['menu' + row + col] = false"
                      @placePax="placePax($event, getCellSeat(col, row))"
                      @movePax="moovingPax($event); menuRefs['menu' + row + col] = false" />
                  </template>
                </v-menu>
                <v-spacer v-if="col.header && columns[index - 1] === 'C'"></v-spacer>
              </template>
            </v-row>
          </v-col>
        </v-row>
      </div>
    </panZoom>
  </div>
</template>

<script setup lang="ts">
import type { VMenu } from 'vuetify/components/VMenu'
import { getRankClass, removeDiacritics } from "../../../mixins/utilsMixin";
import { AircraftEnum } from "~/dto/aircraft.enum";
import { Leg } from "~/dto/leg.dto";
import { Flight } from "~/dto/flight.dto";
import { Aircraft } from "~/dto/aircraft.dto";
import { SeatTemplate } from "~/dto/seat-template.dto";
import { Pax } from "~/dto/pax.dto";
import { Seat } from "~/dto/seat.dto";

const props = defineProps<{
  leg: Leg,
  flight: Flight,
  modes: any,
}>()

const store = useStore();
const instance = getCurrentInstance();
const { $api, $toast } = useNuxtApp();

const menuRefs = ref<Record<string, boolean>>({})
const emit = defineEmits(['lock', 'panzoomInstance']);

const movePax = ref(false);
const loading = ref(false);
const paxToMove: Ref<Pax | null> = ref(null);
const panzoom: Ref<any> = ref(null);
const zones: Ref<any[]> = ref([]);
const columns: Ref<any[]> = ref([]);

const aircrafts: Ref<Aircraft[]> = computed(() => {
  return store.aircrafts;
})
// @ts-ignore
const seatsTemplate: Ref<SeatTemplate[]> = computed(() => {
  return aircrafts.value.find(a => a.name === props.flight?.aircraft?.name)?.seatsTemplate;
})
const getPaxsByLeg: Ref<Pax[]> = computed(() => {
  return props.flight.paxs?.filter(p => p.legs?.findIndex(l => l.id === props.leg.id) >= 0);
})

const getCellClasses = (col: any | number, row: any | string) => {
  const rankClass = getRankClassName(col, row);
  const classes: any = {
    'seat-cell--header': row.header || col.header,
    'seat-cell--hide': isCellHidden(col, row),
    'seat-cell--not-display': !isCellDisplay(col, row),
    'seat-cell--small': col.header,
    'seat-cell--large': isCellLarge(col, row),
    'seat-cell--blocked': getCellSeat(col, row)?.blocked,
    'seat-cell--comment': getCellSeat(col, row)?.observations,
    'cursor-mode': props.modes.commentMode || props.modes.blockMode || (props.modes.placeMode && !getCellSeat(col, row)?.blocked)
  }
  if (rankClass) {
    classes[rankClass] = true;
  }
  return classes;
}
const isCellHidden = (col: any | number, row: any | string): boolean => {
  if (col.header && row.header) {
    return true;
  } else if (col.header || row.header) {
    return false;
  }
  return !(seatsTemplate.value.findIndex(s => s.number === row && s.row === col) >= 0);
}
const isCellDisplay = (col: any | number, row: any | string): boolean => {
  if ((col.header || row.header) && (col?.hide?.includes(row) || row?.hide?.includes(col))) {
    return false;
  }
  if (col.header || row.header) {
    return true;
  }
  switch (props.flight.aircraft.shortName) {
    case AircraftEnum["40_144_88"]:
      if (row >= 34 && col === 'E')
        return false;
      break;
    case AircraftEnum["F-UJCS"]:
      if (row < 5 && ['C', 'F', 'G', 'J'].includes(col))
        return false;
      break;
    case AircraftEnum["F-UJCT"]:
      if (row < 9 && ['F', 'G'].includes(col))
        return false;
      if ((row < 2 || (row < 9 && row > 3)) && ['C', 'J'].includes(col))
        return false;
      break;
    case AircraftEnum["88Y"]:
      if (row >= 34 && col === 'E')
        return false;
      break;
    case AircraftEnum["F-UJCU"]:
      if (row >= 35 && col === 'E')
        return false;
      break;
  }
  return true;
}
const isCellLarge = (col: any | number, row: any | string) => {
  if (col.header) {
    return false;
  }
  switch (props.flight.aircraft.shortName) {
    case AircraftEnum["F-UJCS"]:
      if (row < 5 || row.hide?.length > 0)
        return true;
      break;
    case AircraftEnum["F-UJCT"]:
      if ((row < 9 && !(['A', 'C', 'J', 'K'].includes(col) && (row === 2 || row === 3))))
        return true;
      if (row.hide && ['C', 'F', 'G', 'J'].sort().join(',') === row.hide.sort().join(','))
        return true;
      break;
  }
  return false;
}
const getCellDisplay = (col: string, row: number): string => {
  const seat = getCellSeat(col, row);
  if (seat && seat.pax) {
    let icon = null;
    if (checkObservations(seat.pax.observations, ['VIP'])) {
      icon = 'star';
    } else if (checkObservations(seat.pax.observations, ['Stratevac', 'Medevac', 'Evasan'])) {
      icon = 'medical_services';
    } else if (checkObservations(seat.pax.observations, ['Convoyeur'])) {
      icon = 'work';
    } else if ((seat.pax.animals && seat.pax.animals.length > 0) || checkObservations(seat.pax.observations, ['Maitre-chien'])) {
      icon = 'pets';
    } else if (seat.pax.underage) {
      icon = 'child_care';
    }
    const name = `<div data-cy="SeatCellPax"> ${seat.pax.rank ? `<span class="seat-cell--rank">${seat.pax.rank.name}</span><br/>` : ''}${seat.pax.lastName ? `<span class="seat-cell--name">${seat.pax.lastName}</span></div>` : 'INCONNU'}`;
    return icon ? `<i class="v-icon notranslate material-icons theme--light">${icon}</i> ${name}` : name;
  }
  return `${row}${col}`;
}
const getRankClassName = (col: string, row: number): string | null => {
  const seat = getCellSeat(col, row);
  if (!seat || !seat.pax || !seat.pax.rank) {
    return seat?.pax ? 'seat-cell--no-rank' : '';
  }
  return getRankClass(seat.pax.rank);
}
const getCellSeat = (col: string, row: number): Seat | undefined => {
  return props.leg.seats?.find(s => s.row === col && s.number === row);
}
const handleCellClick = (col: string, row: number) => {
  if (loading.value) {
    return;
  }
  if (props.modes.blockMode) {
    lockCell(col, row)
  } else if (movePax.value) {
    placePax(paxToMove.value, getCellSeat(col, row))
  }
}
const lockCell = async (col: string, row: number) => {
  if (!props.modes.blockMode) {
    return;
  }
  const seat = getCellSeat(col, row);
  if (!seat) {
    return;
  }
  const seatIndex = props.leg.seats?.findIndex(s => s.row === col && s.number === row);
  try {
    loading.value = true;
    if (seat.blocked && props.leg.seats && seatIndex) {
      props.leg.seats[seatIndex] = await $api.seat.unlock(seat.id);
    } else {
      await updateSeats(await $api.seat.lock(seat.id));
    }
    emit('lock');
    $toast.success(seat.blocked ? "Siège débloqué" : "Siège bloqué");
    instance?.proxy?.$forceUpdate();
  } catch (e: any) {
    const message = e.response?.data?.message;
    $toast.error(message || "Erreur lors du blocage du siège");
  }
  loading.value = false;
}
const placePax = async (pax: Pax | null, seat: Seat | null | undefined) => {
  if (!pax || !seat || seat.blocked) {
    return;
  }
  try {
    loading.value = true;
    await updateSeats(await $api.seat.place(seat.id, pax.id));
    props.leg.status = await $api.leg.getStatus(props.leg.id);
    $toast.success(seat.pax ? `Passagers placés et déplacés` : `Passager placé`);
    instance?.proxy?.$forceUpdate();
  } catch (e) {
    $toast.error(`Le placement du passager ${pax.firstName} ${pax.lastName} a échoué`);
  }
  loading.value = false;
  movePax.value = false;
  paxToMove.value = null;
}
const startDrag = (evt: any, col: string, row: number) => {
  evt.dataTransfer.dropEffect = 'move';
  evt.dataTransfer.effectAllowed = 'move';
  const seat = getCellSeat(col, row);
  evt.dataTransfer.setData('seatId', seat?.id);
  panzoom.value?.pause();
}
const onDrop = (evt: any, col: string, row: number) => {
  const seatId = evt.dataTransfer.getData('seatId');
  const seatDropped = props.leg.seats?.find((s) => s.id === seatId);
  const seat = getCellSeat(col, row);
  if (!seatDropped?.pax || !seat || seat.id === seatDropped?.id) {
    return;
  }
  placePax(seatDropped.pax, seat);
}
const endDrag = () => {
  panzoom.value?.resume();
}

const onInitPanzoom = (panzoomInstance: any) => {
  panzoom.value = panzoomInstance;
  emit('panzoomInstance', panzoomInstance);
}
const getAvailablePaxs = () => {
  const paxsToReturn: Pax[] = [];
  getPaxsByLeg.value?.forEach(pax => {
    if (props.leg.seats && props.leg.seats.findIndex(s => s.pax?.id === pax.id) < 0) {
      paxsToReturn.push(pax);
    }
  });
  paxsToReturn.sort((a, b) => a.rank?.category.localeCompare(b.rank?.category));
  paxsToReturn.sort((a, b) => a.rank?.rank - b.rank?.rank);
  return paxsToReturn;
}
const moovingPax = (pax: Pax) => {
  movePax.value = true;
  paxToMove.value = pax;
  $toast.success(`Veuillez sélectionner une autre place non bloquée afin de déplacer le passager ${pax.firstName} ${pax.lastName}`);
}
const updateSeats = async (seats: Seat[]) => {
  seats.forEach(s => {
    if (props.leg.seats) {
      const idx = props.leg.seats.findIndex(ls => ls.id === s.id);
      props.leg.seats[idx] = { ...s };
    }
  });
  props.leg.status = await $api.leg.getStatus(props.leg.id);
}
const getNbPaxByZone = (zoneName: string) => {
  const zone = zones.value.find(z => z.name === zoneName);
  return props.leg.seats?.filter(s => zone.rows.includes(s.number) && !!s.pax).length;
}
const checkObservations = (observations: string, types: string[]) => {
  return types.findIndex(type => {
    const obs = removeDiacritics(observations)?.replace(/[^a-zA-Z]/g, "").trim().toLowerCase();
    return obs ? obs.includes(type.trim().toLowerCase()) : false;
  }) >= 0;
}
watch(() => props.modes, () => {
  movePax.value = false;
  paxToMove.value = null;
},
  { deep: true })

zones.value = seatsTemplate.value.map(s => {
  return { name: s.zone }
}).filter((v, i, a) => a.findIndex(value => value.name === v.name) === i).sort((a, b) => a.name.localeCompare(b.name));
const columnsArray = seatsTemplate.value.map(s => s.row);
columns.value = columnsArray.filter((v, i, a) => a.indexOf(v) === i).sort((a, b) => a.toString().localeCompare(b.toString()));
columns.value.splice(6, 0, { header: true });
columns.value.splice(2, 0, { header: true });


zones.value.forEach(z => {
  z.rows = seatsTemplate.value
    .filter((s: SeatTemplate) => s.zone === z.name)
    .map(s => s.number)
    .filter((v, i, a) => a.indexOf(v) === i)
    .sort((a, b) => a - b);
  z.rows.splice(0, 0, { header: true });
});
switch (props.flight.aircraft.shortName) {
  case AircraftEnum["40_144_88"]:
    zones.value.find(z => z.name === 'OC').rows.splice(9, 0, { header: true, hide: ['E'] });
    break;
  case AircraftEnum["F-UJCU"]:
    zones.value.find(z => z.name === 'OC').rows.splice(10, 0, { header: true, hide: ['E',] });
    break;
  case AircraftEnum["F-UJCS"]:
    zones.value.find(z => z.name === 'OA').rows.splice(0, 1, { header: true, hide: ['C', 'F', 'G', 'J'] });
    break;
  case AircraftEnum["F-UJCT"]:
    zones.value.find(z => z.name === 'OA').rows.splice(0, 1, { header: true, hide: ['C', 'F', 'G', 'J'] });
    zones.value.find(z => z.name === 'OA').rows.splice(2, 0, { header: true, hide: ['D', 'E', 'F', 'G'] });
    zones.value.find(z => z.name === 'OB').rows.splice(0, 1, {
      header: true,
      hide: ['C', 'F', 'G', 'J']
    });
    break;
  case AircraftEnum["88Y"]:
    zones.value.find(z => z.name === 'OC').rows.splice(9, 0, { header: true, hide: ['E'] });
    break;
}

</script>

<style lang="scss">
@import "../../../../assets/variables.scss";

.v-progress-linear {
  z-index: 1;
  position: absolute;
  left: -28px;
  top: -36px;
  width: calc(100% + 80px);
}

.vue-pan-zoom-item {
  overflow: hidden;
  background-color: #F7F8F9;
  position: absolute;
  left: -16px;
  top: -24px;
  width: calc(100% + 32px);
  height: calc(100% + 40px);

  .vue-pan-zoom-scene {
    height: 100%;
  }

  .seats-map {
    width: 715px;

    .seats-zone {
      writing-mode: vertical-rl;
      transform: rotate(-180deg);
      border-radius: 4px;
      box-sizing: border-box;
      margin-top: 30px;
      margin-right: 5px;
      width: 30px;
      display: flex;
      align-items: center;
      justify-content: center;
    }

    .seats-row {
      width: 680px;
    }

    &.loading .seat-cell {
      cursor: not-allowed !important;
    }

    .seat-cell {
      background-color: #ffffff;
      width: 75px;
      height: 30px;
      flex: none;
      display: flex;
      align-items: center;
      justify-content: center;
      margin-left: 2px;
      margin-bottom: 2px;
      border-radius: 4px;
      overflow: hidden;
      font-size: 10px;
      line-height: 12px;
      text-align: center;

      &--header {
        border: 1px solid #EBEBEB;
      }

      &--hide {
        visibility: hidden;
      }

      &--not-display {
        display: none;
      }

      &--small {
        width: 30px;
      }

      &--large {
        width: 152px;
      }

      &--blocked {
        background: $grey-ultra-light;
        cursor: not-allowed;
      }

      &--no-rank {
        background: $color-warning;
      }

      &--comment {
        border: 1px solid $color-secondary;
      }

      &--rank {
        text-transform: uppercase;
      }

      &--name {
        text-transform: lowercase;
      }

      &:not(.seat-cell--header).cursor-mode {
        cursor: pointer;

        &:hover {
          box-shadow: $shadow-uniform;
        }
      }

      &>div {
        width: 100%;
        height: 100%;
        display: flex;
        align-items: center;
        justify-content: center;

        &[role=button] {
          cursor: inherit;
        }
      }

      .v-icon {
        font-size: 14px;
      }
    }
  }
}
</style>
